Imports System.ComponentModel
Imports Aricie.ComponentModel
Imports DotNetNuke.UI.WebControls
Imports Aricie.DNN.UI.WebControls.EditControls

Namespace Aricie.DNN.Caching.Analysis
    <Serializable()> _
    Public Class AutoConfigSettings


        Private _AnalysisFileName As String = "Aricie.DistributedCaching.Analysis.xml"
        Private _EnablePeriodicAnalysis As Boolean
        Private _TriggerKey As String = "GetHostSettings"
        Private _AnalysisPeriod As New STimeSpan(TimeSpan.FromHours(2))
        Private _ChangeDefaultSerializer As New STimeSpan(TimeSpan.FromMinutes(30))
        Private _SwitchIConvertible As New STimeSpan(TimeSpan.FromMinutes(20))
        Private _GenerateStatisticsPeriod As New STimeSpan(TimeSpan.FromMinutes(10))
        Private _ClearRegionsPeriod As New STimeSpan(TimeSpan.FromSeconds(90))
        Private _ClearLocalCachePeriod As New STimeSpan(TimeSpan.FromSeconds(30))

        'Private _OverrideStatistics As Boolean
        Private _SkipBinarySerializer As Boolean
        Private _AlwaysUpdateStatistics As Boolean

        Private _OverrideKeysOnAutoConfig As Boolean

        Private _NoMainGroups As Boolean
        Private _NoClusters As Boolean
        Private _MinGroupSize As Integer = 5
        Private _IndividualStrategies As Boolean



        Private _MaxCoefOfVariation As Integer = 70
        Private _MinLossForNoDistribution As Integer = 1000
        Private _MinGainForDistribution As Integer = 90
        Private _MaxLossForBatch As Integer = 600
        Private _MinPercentageNextKeyForGroup As Integer = 70
        Private _MinPercentagePrevKeyForGroup As Integer = 20


        <Category("")> _
            <MainCategory()> _
        Public Property AnalysisFileName() As String
            Get
                Return _AnalysisFileName
            End Get
            Set(ByVal value As String)
                _AnalysisFileName = value
            End Set
        End Property

        <Category("")> _
        Public Property EnablePeriodicAnalysis() As Boolean
            Get
                Return _EnablePeriodicAnalysis
            End Get
            Set(ByVal value As Boolean)
                _EnablePeriodicAnalysis = value
            End Set
        End Property

        <Category("")> _
        Public Property OverrideKeysOnAutoConfig() As Boolean
            Get
                Return _OverrideKeysOnAutoConfig
            End Get
            Set(ByVal value As Boolean)
                _OverrideKeysOnAutoConfig = value
            End Set
        End Property

        <Category("UpdateSettings")> _
        Public Property AlwaysUpdateStatistics() As Boolean
            Get
                Return _AlwaysUpdateStatistics
            End Get
            Set(ByVal value As Boolean)
                _AlwaysUpdateStatistics = value
            End Set
        End Property

        '<Category("UpdateSettings")> _
        'Public Property OverrideStatistics() As Boolean
        '    Get
        '        Return _OverrideStatistics
        '    End Get
        '    Set(ByVal value As Boolean)
        '        _OverrideStatistics = value
        '    End Set
        'End Property

        <Category("AutomationSettings")> _
        Public Property TriggerKey() As String
            Get
                Return _TriggerKey
            End Get
            Set(ByVal value As String)
                _TriggerKey = value
            End Set
        End Property

        <Category("AutomationSettings")> _
       Public Property SkipBinarySerializer() As Boolean
            Get
                Return _SkipBinarySerializer
            End Get
            Set(ByVal value As Boolean)
                _SkipBinarySerializer = value
            End Set
        End Property

        <Category("AutomationSettings")> _
            <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
            <LabelMode(LabelMode.Top)> _
        Public Property AnalysisPeriod() As STimeSpan
            Get
                Return _AnalysisPeriod
            End Get
            Set(ByVal value As STimeSpan)
                _AnalysisPeriod = value
            End Set
        End Property

       

        <Category("AutomationSettings")> _
       <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
      <LabelMode(LabelMode.Top)> _
       Public Property ChangeDefaultSerializer() As STimeSpan
            Get
                Return _ChangeDefaultSerializer
            End Get
            Set(ByVal value As STimeSpan)
                _ChangeDefaultSerializer = value
            End Set
        End Property

        <Category("AutomationSettings")> _
      <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
     <LabelMode(LabelMode.Top)> _
      Public Property SwitchIConvertiblePeriod() As STimeSpan
            Get
                Return _SwitchIConvertible
            End Get
            Set(ByVal value As STimeSpan)
                _SwitchIConvertible = value
            End Set
        End Property

       


        <Category("AutomationSettings")> _
            <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
            <LabelMode(LabelMode.Top)> _
        Public Property GenerateStatisticsPeriod() As STimeSpan
            Get
                Return _GenerateStatisticsPeriod
            End Get
            Set(ByVal value As STimeSpan)
                _GenerateStatisticsPeriod = value
            End Set
        End Property

        <Category("AutomationSettings")> _
            <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
            <LabelMode(LabelMode.Top)> _
        Public Property ClearRegionsPeriod() As STimeSpan
            Get
                Return _ClearRegionsPeriod
            End Get
            Set(ByVal value As STimeSpan)
                _ClearRegionsPeriod = value
            End Set
        End Property

        <Category("AutomationSettings")> _
            <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
            <LabelMode(LabelMode.Top)> _
        Public Property ClearLocalCachePeriod() As STimeSpan
            Get
                Return _ClearLocalCachePeriod
            End Get
            Set(ByVal value As STimeSpan)
                _ClearLocalCachePeriod = value
            End Set
        End Property






        <Category("GroupSettings")> _
        Public Property NoMainGroups() As Boolean
            Get
                Return _NoMainGroups
            End Get
            Set(ByVal value As Boolean)
                _NoMainGroups = value
            End Set
        End Property

        <Category("GroupSettings")> _
        Public Property NoClusters() As Boolean
            Get
                Return _NoClusters
            End Get
            Set(ByVal value As Boolean)
                _NoClusters = value
            End Set
        End Property

        <Category("GroupSettings")> _
            <Required(True)> _
        Public Property MinGroupSize() As Integer
            Get
                Return _MinGroupSize
            End Get
            Set(ByVal value As Integer)
                _MinGroupSize = value
            End Set
        End Property

        <Category("GroupSettings")> _
        Public Property IndividualStrategies() As Boolean
            Get
                Return _IndividualStrategies
            End Get
            Set(ByVal value As Boolean)
                _IndividualStrategies = value
            End Set
        End Property



        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MaxCoefOfVariation() As Integer
            Get
                Return _MaxCoefOfVariation
            End Get
            Set(ByVal value As Integer)
                _MaxCoefOfVariation = value
            End Set
        End Property

        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MinLossForNoDistribution() As Integer
            Get
                Return _MinLossForNoDistribution
            End Get
            Set(ByVal value As Integer)
                _MinLossForNoDistribution = value
            End Set
        End Property


        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MinGainForDistribution() As Integer
            Get
                Return _MinGainForDistribution
            End Get
            Set(ByVal value As Integer)
                _MinGainForDistribution = value
            End Set
        End Property

        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MaxLossForBatch() As Integer
            Get
                Return _MaxLossForBatch
            End Get
            Set(ByVal value As Integer)
                _MaxLossForBatch = value
            End Set
        End Property

        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MinPercentageNextKeyForGroup() As Integer
            Get
                Return _MinPercentageNextKeyForGroup
            End Get
            Set(ByVal value As Integer)
                _MinPercentageNextKeyForGroup = value
            End Set
        End Property

        <Category("ToleranceSettings")> _
            <Required(True)> _
        Public Property MinPercentagePrevKeyForGroup() As Integer
            Get
                Return _MinPercentagePrevKeyForGroup
            End Get
            Set(ByVal value As Integer)
                _MinPercentagePrevKeyForGroup = value
            End Set
        End Property




    End Class
End Namespace