Imports System.ComponentModel
Imports Aricie.DNN.UI.Attributes
Imports Aricie.DNN
Imports Aricie.ComponentModel
Imports DotNetNuke.UI.WebControls
Imports Aricie.DNN.UI.WebControls.EditControls

Namespace Aricie.DNN.Caching.Analysis
    <Serializable()> _
    Public Class StatisticsSettings

        Private _StatisticsFileName As String = "Aricie.DistributedCaching.Stats.xml"
        Private _UpdateExistingStats As Boolean = True
        Private _MinSampleNumber As Integer = 3
        Private _MinSampleDeviation As Integer = 25
        Private _MaxSampleDeviation As Integer = 400
        Private _MinSequenceRatioToBest As Integer = 9
        Private _MinSequenceRatioForGraph As Integer = 20
        Private _MaxSequenceDuration As New STimeSpan(TimeSpan.FromMilliseconds(250))




        <Category("")> _
            <MainCategory()> _
            <Required(True)> _
        Public Property StatisticsFileName() As String
            Get
                Return _StatisticsFileName
            End Get
            Set(ByVal value As String)
                _StatisticsFileName = value
            End Set
        End Property

        <Category("")> _
        Public Property UpdateExistingStats() As Boolean
            Get
                Return _UpdateExistingStats
            End Get
            Set(ByVal value As Boolean)
                _UpdateExistingStats = value
            End Set
        End Property

        <Category("AdvancedSettings")> _
            <Required(True)> _
        Public Property MinSampleNumber() As Integer
            Get
                Return _MinSampleNumber
            End Get
            Set(ByVal value As Integer)
                _MinSampleNumber = value
            End Set
        End Property

        <Category("AdvancedSettings")> _
            <Required(True)> _
        Public Property MinSampleDeviation() As Integer
            Get
                Return _MinSampleDeviation
            End Get
            Set(ByVal value As Integer)
                _MinSampleDeviation = value
            End Set
        End Property

        <Category("AdvancedSettings")> _
            <Required(True)> _
        Public Property MaxSampleDeviation() As Integer
            Get
                Return _MaxSampleDeviation
            End Get
            Set(ByVal value As Integer)
                _MaxSampleDeviation = value
            End Set
        End Property

        <Category("AdvancedSettings")> _
            <Required(True)> _
        Public Property MinSequenceRatioToBest() As Integer
            Get
                Return _MinSequenceRatioToBest
            End Get
            Set(ByVal value As Integer)
                _MinSequenceRatioToBest = value
            End Set
        End Property

        <Category("AdvancedSettings")> _
            <Required(True)> _
        Public Property MinSequenceRatioForGraph() As Integer
            Get
                Return _MinSequenceRatioForGraph
            End Get
            Set(ByVal value As Integer)
                _MinSequenceRatioForGraph = value
            End Set
        End Property


        <Category("AdvancedSettings")> _
            <Editor(GetType(PropertyEditorEditControl), GetType(EditControl))> _
            <LabelMode(LabelMode.Top)> _
        Public Property MaxSequenceDuration() As STimeSpan
            Get
                Return _MaxSequenceDuration
            End Get
            Set(ByVal value As STimeSpan)
                _MaxSequenceDuration = value
            End Set
        End Property







    End Class
End Namespace