Imports System.Xml.Serialization
Imports System.ComponentModel
Imports Aricie.DNN.UI.Attributes
Imports Aricie.ComponentModel
Imports DotNetNuke.UI.WebControls

Namespace Aricie.DNN.Caching
    <Serializable()> _
    Public Class LocalCacheSettings

        Private _LocalEnabled As Boolean = True
        Private _EnableGlobalDependency As Boolean = True



        <XmlIgnore()> _
            <Category("")> _
            <MainCategory()> _
        Public ReadOnly Property NbItemsInLocalCache() As Integer
            Get
                Return DistributedCachingProviderBase.WebCache.Count
            End Get
        End Property

        <XmlIgnore()> _
            <Category("")> _
        Public ReadOnly Property EffectivePercentagePhysicalMemoryLimit() As String
            Get
                Return DistributedCachingProviderBase.WebCache.EffectivePercentagePhysicalMemoryLimit.ToString & "%"
            End Get
        End Property

        <XmlIgnore()> _
            <Category("")> _
        Public ReadOnly Property EffectivePrivateBytesLimit() As String
            Get
                Return DistributedCachingProviderBase.WebCache.EffectivePrivateBytesLimit.ToString
            End Get
        End Property

        <ExtendedCategory("")> _
        Public Property LocalEnabled() As Boolean
            Get
                Return _LocalEnabled
            End Get
            Set(ByVal value As Boolean)
                _LocalEnabled = value
            End Set
        End Property

        <ExtendedCategory("")> _
        Public Property EnableGlobalDependency() As Boolean
            Get
                Return _EnableGlobalDependency
            End Get
            Set(ByVal value As Boolean)
                _EnableGlobalDependency = value
            End Set
        End Property


        <XmlIgnore()> _
            <ExtendedCategory("Keys")> _
            <LabelMode(LabelMode.Top)> _
        Public ReadOnly Property LocalKeys() As String
            Get
                Dim sortedKeys As List(Of String) = DistributedCachingProviderBase.GetAllLocalKeys
                sortedKeys.Sort()
                Return CacheStrategy.FormatKeys(sortedKeys.ToArray)
            End Get
        End Property

        

    End Class
End NameSpace