Imports Aricie.DNN.Caching.Analysis
Imports Aricie.DNN.UI.Controls
Imports Aricie.DNN.Settings
Imports DotNetNuke.Common
Imports DotNetNuke.UI.Skins.Controls
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Services.Localization
Imports DotNetNuke.UI.Skins
Imports Aricie.DNN.Security.Trial

Namespace Aricie.DNN.Caching.UI

    Partial Class DistributedCachingProviderConfig
        Inherits AriciePortalModuleBase

        Protected ReadOnly Property DistributedCachingSettings() As DistributedCachingProviderSettings
            Get
                If ViewState("DistributedCachingSettings") Is Nothing Then
                    ViewState("DistributedCachingSettings") = DistributedCachingProviderBase.Settings
                End If
                Return CType(ViewState("DistributedCachingSettings"), DistributedCachingProviderSettings)
            End Get
        End Property

#Region "Event Handlers"

        Private Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
            Me.EnforceFreeVersion()

        End Sub

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
            Try
                If Not Me.IsPostBack Then
                    If AssertInstalled() Then
                        Try
                            Me.chkShowConfig.Checked = SettingsController.GetPersonalSettings(Me.PortalId).Get(Of Boolean)(Me.chkShowConfig.ID, False)
                            Me.chkShowStats.Checked = SettingsController.GetPersonalSettings(Me.PortalId).Get(Of Boolean)(Me.chkShowStats.ID, False)
                            Me.chkShowAnalysis.Checked = SettingsController.GetPersonalSettings(Me.PortalId).Get(Of Boolean)(Me.chkShowAnalysis.ID, False)
                        Catch ex As Exception
                            DotNetNuke.Services.Exceptions.Exceptions.LogException(ex)
                        End Try
                        


                        If Me.chkShowStats.Checked Then
                            Me.cmdClearStats.Focus()
                        End If
                        If Me.DistributedCachingSettings.ClientSettings.Clusters.Count = 0 Then
                            Skin.AddModuleMessage(Me, Localization.GetString("Welcome.Message", Me.LocalResourceFile), _
                                                   ModuleMessage.ModuleMessageType.GreenSuccess)
                        End If
                    End If
                End If
                Me.BindSettings()


            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub




        Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
            Try
                Me.chkAutoConfigure.Checked = Me.DistributedCachingSettings.AutoConfigSettings.EnablePeriodicAnalysis AndAlso Me.DistributedCachingSettings.LoggingSettings.EnableStatsCollector
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        'Config

        Private Sub chkShowConfig_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkShowConfig.CheckedChanged
            Try
                Dim persoSettings As PersonalSettings = SettingsController.GetPersonalSettings(Me.PortalId)
                persoSettings.Put(Of Boolean)(Me.chkShowConfig.ID, Me.chkShowConfig.Checked)
                Aricie.DNN.Settings.SettingsController.SetPersonalSettings(Me.PortalId, persoSettings, True)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Protected Sub cmdSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdSave.Click
            Try
                If Me.ctlSettings.IsValid Then
                    Dim settings As DistributedCachingProviderSettings = DirectCast(Me.ctlSettings.DataSource, DistributedCachingProviderSettings)

                    DistributedCachingBusinessController.SaveSettings(settings)
                    Skin.AddModuleMessage(Me, Localization.GetString("ConfigSaved.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                    Me.BindSettings()
                Else
                    Skin.AddModuleMessage(Me, Localization.GetString("ConfigInvalid.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.YellowWarning)
                End If
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub chkAutoConfigure_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkAutoConfigure.CheckedChanged
            Try
                Dim settings As DistributedCachingProviderSettings = DirectCast(Me.ctlSettings.DataSource, DistributedCachingProviderSettings)
                If Me.chkAutoConfigure.Checked Then
                    settings.Enabled = True
                    settings.LocalCacheSettings.LocalEnabled = True
                    settings.LocalCacheSettings.EnableGlobalDependency = True
                    'settings.ClientSettings.AutoCreateRegions = True
                    settings.CloudSettings.EnableSynchronization = False
                    settings.CloudSettings.EnableDistributedCache = True
                    settings.CloudSettings.EnforceXmlSerialization = True
                    settings.CloudSettings.DefaultKeyConfig.DistributionType = CacheDistributionType.Undefined
                    settings.CloudSettings.DefaultKeyConfig.RegionName = "AutoConfig"
                    settings.CloudSettings.DefaultKeyConfig.EvictionsOn = False
                    settings.CloudSettings.DefaultKeyConfig.DisableClusterRemoval = True
                    settings.CloudSettings.DefaultKeyConfig.LogOperations = True
                    settings.LoggingSettings.EnableDebugLogging = True
                    settings.LoggingSettings.EnableStatsCollector = True
                    settings.StatisticsSettings.UpdateExistingStats = True
                    settings.AutoConfigSettings.EnablePeriodicAnalysis = True
                    DistributedCachingBusinessController.SaveSettings(settings)
                    DistributedCachingBusinessController.AnalyzeTaskQueue.EnqueueTask(Now)
                    Skin.AddModuleMessage(Me, Localization.GetString("AutoConfigOn.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)

                Else
                    settings.CloudSettings.EnableSynchronization = True
                    settings.CloudSettings.EnforceXmlSerialization = False
                    settings.CloudSettings.DefaultKeyConfig.RegionName = ""
                    settings.CloudSettings.DefaultKeyConfig.EvictionsOn = True
                    settings.CloudSettings.DefaultKeyConfig.DisableClusterRemoval = False
                    settings.CloudSettings.DefaultKeyConfig.DistributionType = CacheDistributionType.NotDistributed
                    settings.LoggingSettings.EnableStatsCollector = False
                    settings.AutoConfigSettings.EnablePeriodicAnalysis = False
                    DistributedCachingBusinessController.SaveSettings(settings)
                    Skin.AddModuleMessage(Me, Localization.GetString("AutoConfigOff.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                End If
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Protected Sub cmdInstall_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdInstall.Click
            Try
                Aricie.DNN.Configuration.ConfigHelper.ProcessModuleUpdate(Configuration.ConfigActionType.Install, New DistributedCachingConfigUpdate)
                Me.Reset()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Protected Sub cmdUninstall_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdUninstall.Click
            Try
                Configuration.ConfigHelper.ProcessModuleUpdate(Configuration.ConfigActionType.Uninstall, New DistributedCachingConfigUpdate)
                Response.Redirect(Me.Request.Url.AbsoluteUri)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdDefault_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDefault.Click
            Try
                Me.Reset()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


        Private Sub cmdClearCache_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdClearCache.Click
            Try
                If Me.txtCacheKey.Text = "" Then
                    DistributedCachingProviderBase.ClearCache(Not Me.chkRemoveWithoutDependency.Checked)
                Else
                    DistributedCachingProviderBase.Instance.Remove(Me.txtCacheKey.Text.Trim)
                End If
                Me.BindSettings()
                'Response.Redirect(NavigateURL)
                Skin.AddModuleMessage(Me, Localization.GetString("CacheCleared.Message", Me.LocalResourceFile), _
                                          ModuleMessage.ModuleMessageType.GreenSuccess)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


        Private Sub cmdResetRegions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdResetRegions.Click
            Try
                If txtRegionName.Text.Trim = "" Then
                    DistributedCachingProviderBase.ClearRegions()
                Else
                    DistributedCachingProviderBase.ClearRegion(txtRegionName.Text.Trim)
                End If
                Me.BindSettings()
                Skin.AddModuleMessage(Me, Localization.GetString("RegionsReset.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdDeleteRegions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDeleteRegions.Click
            Try
                If txtRegionName.Text.Trim = "" Then
                    DistributedCachingProviderBase.DeleteRegions()
                Else
                    DistributedCachingProviderBase.DeleteRegion(txtRegionName.Text.Trim)
                End If
                Me.BindSettings()
                Skin.AddModuleMessage(Me, Localization.GetString("RegionsDeleted.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


        'Stats


        Private Sub cmdComputeStats_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdComputeStats.Click
            Try
                DistributedCachingBusinessController.BuildStatsFromLogs(DistributedCachingProviderBase.Settings, DistributedCachingBusinessController.LoadStatistics)
                Me.chkShowStats.Checked = True
                Skin.AddModuleMessage(Me, Localization.GetString("StatisticsComputed.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub chkShowStats_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkShowStats.CheckedChanged
            Try
                Dim persoSettings As PersonalSettings = SettingsController.GetPersonalSettings(Me.PortalId)
                persoSettings.Put(Of Boolean)(Me.chkShowStats.ID, Me.chkShowStats.Checked)
                Aricie.DNN.Settings.SettingsController.SetPersonalSettings(Me.PortalId, persoSettings, True)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub





        Private Sub cmdClearStats_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdClearStats.Click
            Try
                DistributedCachingBusinessController.SaveStatistics(New CacheStatistics)
                Skin.AddModuleMessage(Me, Localization.GetString("StatisticsCleared.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdSaveStats_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdSaveStats.Click
            Try
                DistributedCachingBusinessController.SaveStatistics(DirectCast(Me.ctlStats.DataSource, CacheStatistics))
                Skin.AddModuleMessage(Me, Localization.GetString("StatisticsSaved.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


        'Analysis

        Private Sub chkShowAnalysis_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkShowAnalysis.CheckedChanged
            Try
                Dim persoSettings As PersonalSettings = SettingsController.GetPersonalSettings(Me.PortalId)
                persoSettings.Put(Of Boolean)(Me.chkShowAnalysis.ID, Me.chkShowAnalysis.Checked)
                Aricie.DNN.Settings.SettingsController.SetPersonalSettings(Me.PortalId, persoSettings, True)

            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdConfigureFromStats_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdConfigureFromStats.Click
            Try

                DistributedCachingBusinessController.PerformAnalysisFromStatistics(DistributedCachingBusinessController.LoadStatistics, DistributedCachingProviderBase.Settings)
                Me.chkShowAnalysis.Checked = True
                Skin.AddModuleMessage(Me, Localization.GetString("AnalysisComputed.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdApplyEdits_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdApplyEdits.Click
            Try
                DistributedCachingBusinessController.ApplyAnalysisRecommandations(DistributedCachingBusinessController.LoadAnalysis, Me.DistributedCachingSettings)
                Skin.AddModuleMessage(Me, Localization.GetString("AnalysisApplied.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.chkShowConfig.Checked = True
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


        Private Sub cmdSaveAnalysis_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdSaveAnalysis.Click
            Try
                DistributedCachingBusinessController.SaveAnalysis(DirectCast(Me.ctlAnalysis.DataSource, CacheAnalysis))
                Skin.AddModuleMessage(Me, Localization.GetString("AnalysisSaved.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
                Me.BindSettings()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub cmdClearAnalysis_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdClearAnalysis.Click
            Try
                DistributedCachingBusinessController.SaveAnalysis(New CacheAnalysis)
                Skin.AddModuleMessage(Me, Localization.GetString("AnalysisSaved.Message", Me.LocalResourceFile), _
                                           ModuleMessage.ModuleMessageType.GreenSuccess)
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub


#End Region

#Region "Private methods"

        Private Sub EnforceFreeVersion()

            Dim tc As TrialController = TrialController.Instance(New TrialProvider())
            Dim objTrialStatus As TrialStatusInfo = tc.LimitModule(Me, True)
            Me.ctlSettings.TrialStatus = objTrialStatus
            'If objTrialStatus.Status = TrialStatus.Expired Then
            '    Me.cmdSave.Enabled = False
            'End If

        End Sub


        Private Sub BindSettings()
            If Me.chkShowConfig.Checked Then
                Me.ctlSettings.LocalResourceFile = Me.SharedResourceFile
                Me.ctlSettings.DataSource = Me.DistributedCachingSettings
                Me.ctlSettings.DataBind()
                Me.divShowConfig.Visible = True

            Else
                Me.divShowConfig.Visible = False
            End If

            If Me.chkShowStats.Checked Then
                Dim stats As CacheStatistics = DistributedCachingBusinessController.LoadStatistics
                BindStatistics(stats)
                Me.divStatList.Visible = True
            Else
                Me.divStatList.Visible = False
            End If
            If Me.chkShowAnalysis.Checked Then
                BindAnalysis(DistributedCachingBusinessController.LoadAnalysis)
                Me.divShowAnalysis.Visible = True
            Else
                Me.divShowAnalysis.Visible = False
            End If

        End Sub

        Private Sub BindStatistics(ByVal stats As CacheStatistics)
            Me.ctlStats.LocalResourceFile = Me.SharedResourceFile
            Me.ctlStats.DataSource = stats
            Me.ctlStats.DataBind()
        End Sub

        Private Sub BindAnalysis(ByVal obj As CacheAnalysis)
            Me.ctlAnalysis.LocalResourceFile = Me.SharedResourceFile
            Me.ctlAnalysis.DataSource = obj
            Me.ctlAnalysis.DataBind()
        End Sub

        Private Sub ApplyAnalysis(ByVal analysis As CacheAnalysis)

            For Each group As CacheGroupInfo In analysis.GroupStrategies

                If Not Me.DistributedCachingSettings.CloudSettings.GroupStrategies.Contains(group) Then
                    Me.DistributedCachingSettings.CloudSettings.GroupStrategies.Add(group)
                Else

                End If


            Next


        End Sub

        Private Sub Reset()
            DistributedCachingBusinessController.SaveSettings(Me.GetDefaultSettings)
            Me.Response.Redirect(NavigateURL())
        End Sub

        Private Function AssertInstalled() As Boolean
            Dim updater As New DistributedCachingConfigUpdate
            Aricie.DNN.Configuration.ConfigHelper.AssertIsInstalled(Me, updater, Me.cmdInstall, New Control() {Me.cmdUninstall, Me.divConfig})
            If Me.UserInfo.IsSuperUser Then
                Me.divInstall.Visible = True
            Else
                Me.divInstall.Visible = False
            End If
            Return Aricie.DNN.Configuration.ConfigHelper.IsInstalled(updater, True)
        End Function


        Private Function GetDefaultSettings() As DistributedCachingProviderSettings
            Dim toReturn As New DistributedCachingProviderSettings
            toReturn.ClientSettings.AddDefaultProviders()
            toReturn.CloudSettings.StartupKeys.Add(toReturn.CloudSettings.CatalogKey)
            Return toReturn
        End Function

#End Region


    End Class
End Namespace